import { FormulaireFixedVar } from "./form-fixedvar";
import { FieldSet } from "../elements/fieldset";
import { ServiceFactory } from "../../services/service-factory";

import { IObservable, Session, SectionNub } from "jalhyd";

export class FormulaireSection extends FormulaireFixedVar {

    public update(sender: IObservable, data: any) {
        super.update(sender, data);
        // changement de propriété du FieldSet contenant le select de choix du type de section
        if (sender instanceof FieldSet && sender.id === "fs_section" && data.action === "propertyChange") {
            // replace underlying section without replacing whole Nub
            const newSect = Session.getInstance().createSection(data.value);
            (this._currentNub as SectionNub).setSection(newSect);
            // reflect changes in GUI
            for (const fs of this.allFieldsets) {
                // show / hide dependent fields
                fs.updateFields();
            }
            // show / hide dependent fields
            this.refreshFieldsets();
            // empty fields ? only those belonging to the specific section type
            if (ServiceFactory.instance.applicationSetupService.enableEmptyFieldsOnFormInit) {
                // "LargeurBerge" is hackily used as LargeurFond in Rectangular and Trapez sections, omit it here
                this.emptyFields([ "Ks", "Q", "If", "YB", "iPrec", "Y" ]);
            }
            this.reset();
        }
    }

}
